commit d7f9edb4473f3f12c23c9a3f044c955eba6d16d1
Author: Robin Dapp <rdapp@ventanamicro.com>
Date:   Mon Dec 8 10:22:51 2025

    RISC-V: Add more mode_idx attributes [PR123022].
    
    Similar to 116149 we use the mode size of operand MODE_IDX but that
    one could refer to a broadcast scalar.  Use operand 3 for scalar
    broadcast patterns instead.
    
            PR target/123022
    
    gcc/ChangeLog:
    
            * config/riscv/vector.md: Add mode_idx attribute.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/riscv/rvv/autovec/pr123022-2.c: New test.
            * gcc.target/riscv/rvv/autovec/pr123022.c: New test.
    
    (cherry picked from commit 195471cc076d05ac1b3e2c2ed0b8cfedb0ac97a1)

diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022-2.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022-2.c
new file mode 100644
index 00000000000..0562b566fa8
--- /dev/null
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022-2.c
@@ -0,0 +1,6 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -march=rv64gcv_zvl512b -mabi=lp64d -mrvv-vector-bits=zvl -fsigned-char" } */
+
+#include "pr123022.c"
+
+/* { dg-final { scan-assembler-not "vset.*zero,1," } } */
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022.c
new file mode 100644
index 00000000000..1f5f165a02b
--- /dev/null
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/pr123022.c
@@ -0,0 +1,21 @@
+/* { dg-do run } */
+/* { dg-require-effective-target rvv_zvl512b_ok } */
+/* { dg-options "-O3 -march=rv64gcv_zvl512b -mabi=lp64d -mrvv-vector-bits=zvl -fsigned-char" } */
+unsigned e[2][2];
+long a;
+char c[2];
+
+int
+main ()
+{
+  long long b;
+  c[1] = 3;
+  for (unsigned h = 0; h < 2; h++)
+    for (int i = c[0]; i < 5; i += 5)
+      for (int j = 0; j < 219; j++)
+	a = c[h] ? e[h][h] + 3326195747 : 0;
+
+  b = a;
+  if (b != 3326195747)
+    __builtin_abort ();
+}

